package waterPaint;
import controlP5.ControlP5;
import processing.core.PApplet;

@SuppressWarnings("serial")
public class WaterPaint_v05 extends PApplet{
	int W,H;//ʒ
	
	MyImageBuffer dBuf;//`惌C[(̓f[^̈ꎞۑC[W)
	MyImageBuffer dPap;//LpXC[(FۂɒC[W)
	ControlP5 controlP5;//XC_[,{^
	int red,green,blue,water,Bsize;//XC_[pϐ
	
	float A,D,loopTime;//ɂ݌WAWA
	int penWater;//M̐
	int colorR,colorG,colorB;//FƂ̃CN	
	
	public void setup(){
		W = H = 200;
		size(W, H+200);
		dBuf = new MyImageBuffer(W,H);
		dPap = new MyImageBuffer(W,H);
		
		A = 0.2f;
		D = 0.4f;
		loopTime = 4;
		
		penWater = 200;
		
		red=green=blue=water=Bsize=0;
		controlP5 = new ControlP5(this);
		controlP5.addSlider("red",0,255,100,20,H+40,100,10);
		controlP5.addSlider("green",0,255,100,20,H+80,100,10);
		controlP5.addSlider("blue",0,255,100,20,H+120,100,10);
		controlP5.addSlider("water",0,255,100,20,H+160,100,10);
		controlP5.addSlider("Bsize",10,80,30,140,H+40,50,10);
		controlP5.addButton("reset", 255, 140, H+80, 40, 20);
		
		background(255);
	}

	public void draw(){		
		background(255);
		fill(200);
		rect(0, H+1, W, 200);
		noFill();
		stroke(0);
		strokeWeight(Bsize);
		/*y`揈 */
		if(mousePressed && mouseY<=H) line(mouseX, mouseY, pmouseX, pmouseY);
		noStroke();
		loadPixels();
		
		colorR = 255-red;
		colorG = 255-green;
		colorB = 255-blue;
		penWater = 255-water;
		
		/*
		 * `pobt@ł̐̂ɂݏ
		 * Xg[Nɐ̂܂ܗ݁AX^[ŁAXV݂̂ɂݏs
		 */	
		for(int j=0;j<H;j++){ for(int i=0;i<W;i++){
			if(pixels[j*W+i] != color(255)) {
				double dist = Math.sqrt(Math.abs(mouseX-i)*Math.abs(mouseX-i)+Math.abs(mouseY-j)*Math.abs(mouseY-j));
				dBuf.waters[i][j] = (int) (penWater-dist);
			}
		}}
		for(int time=0;time<loopTime;time++){
			for(int j=0;j<H;j++){ for(int i=0;i<W;i++){
				if(dBuf.waters[i][j] != 0){
					int sum = dBuf.waters[i][j];
					sum = neighborhood8(sum, dBuf.waters, i, j);
					dBuf.waters[i][j] = (int) ((float)((1-A) * dBuf.waters[i][j] + A * sum)/(float)(1+8*A));
					dBuf.colors[0][i][j] = (int)(colorR * (float)dBuf.waters[i][j]/255);
					dBuf.colors[1][i][j] = (int)(colorG * (float)dBuf.waters[i][j]/255);
					dBuf.colors[2][i][j] = (int)(colorB * (float)dBuf.waters[i][j]/255);
					//System.out.println(dBuf.colors[0][i][j]+","+dBuf.colors[1][i][j]+","+dBuf.colors[2][i][j]);
				}
		}}}

		/*
		 * C[ɁA`pobt@ōXVꂽ̂ɂ݂𔽉f
		 */
		for(int j=0;j<H;j++){for(int i=0;i<W;i++){
			dPap.waters[i][j] += dBuf.waters[i][j];
		}}
		paperLayerBlur();

		/**
		 * IIIIIIFIII
		 */
		for(int j=0;j<H;j++){for(int i=0;i<W;i++){
			if(dPap.waters[i][j]!=0){
				for(int k=0;k<3;k++){
					dPap.colors[k][i][j] += A*dBuf.colors[k][i][j];//= (int)((dBuf.colors[i][j]+dPap.colors[i][j]) * (float)dPap.waters[i][j]/255);
					if(dPap.colors[k][i][j]>255) dPap.colors[k][i][j] = 255;
					else if(dPap.colors[k][i][j]<0) dPap.colors[k][i][j] = 0;
				}
				//System.out.println(dPap.colors[0][i][j]+","+dPap.colors[1][i][j]+","+dPap.colors[2][i][j]);
				//dPap.colors[i][j] = penInkWeight;
			}
		}}

		/*
		 * C[̎dグ̂ɂݏ
		 */
		paperLayerBlur();			

		/*
		 * 摜̍XV 
		 */
		dPap.pg.loadPixels();
		for(int j=0;j<H;j++){for(int i=0;i<W;i++){
			int r = 255 - dPap.colors[0][i][j];
			int g = 255 - dPap.colors[1][i][j];
			int b = 255 - dPap.colors[2][i][j];
			if(pixels[j*W+i]!=color(255)){
				int alpha = 255-dPap.waters[i][j];
				//if(alpha < 10) alpha = 10;
				dPap.pg.pixels[j*W+i] = color(r,g,b,alpha);
			}else
				dPap.pg.pixels[j*W+i] = color(r,g,b);
		}}
		dPap.pg.updatePixels();
		dBuf.pg.background(255);
		dBuf.reset();
		image(dPap.pg, 0, 0);
	
		/*
		 * 
		 */
		for(int j=0;j<H;j++){for(int i=0;i<W;i++){
			dPap.waters[i][j] *= D;
		}}
	}
	
	static public void main(String args[]) { 
	     PApplet.main(new String[] { "waterPaint.WaterPaint_v05" }  )  ; 
	} 
	
	private void paperLayerBlur(){
		for(int time=0;time<loopTime;time++){
			for(int j=0;j<H;j++){for(int i=0;i<W;i++){
				if(dPap.waters[i][j]!=0){
					float t = (A*dPap.waters[i][j]) / 255;
					for(int k=0;k<3;k++){
						int sum = dPap.colors[k][i][j];
						sum = neighborhood8(sum, dPap.colors[k], i, j);
						dPap.colors[k][i][j] = (int) (((1-t)*dPap.colors[k][i][j] + t * sum) / (float)(1 + 8*t));
					}
				}
				dPap.waters[i][j] *= D;
			}}
		}
	}
	
	private int neighborhood8(int sum, int[][] data, int i, int j){
		if(i!=0 && j!=0) sum += data[i-1][j-1];
		if(i!=0) sum += data[i-1][ j ];
		if(i!=0 && j!=H-1) sum += data[i-1][j+1];
		if(j!=0) sum += data[i][j-1];
		if(j!=H-1) sum += data[i][j+1];
		if(i!=W-1 && j!=0) sum+= data[i+1][j-1];
		if(i!=W-1) sum += data[i+1][ j ];
		if(i!=W-1 && j!=H-1) sum += data[i+1][j+1];
		return sum;
	}
	
	void reset(int i){
		dPap.destroy();
		dPap = new MyImageBuffer(W, H);
	}
}
